#include <Servo.h>

Servo motor;

int schalterGestellPin = A0;
int schalterHebebObenPin = A1;
int schalterHebebUntenPin = A2;
int motorEN_Pin = A3;
int motorA1_Pin = 2;
int motorB1_Pin = 3;
int motorPWM_Pin = 4;
int servoPin = 6;

int motorGeschwinigkeit = 0;

int motorRichtung = 0; //Wert 0 = motor dreht sich nicht, Wert 1 = rechtsdrehend, Wert 2 = linksdrehend


void setup() {
  Serial.begin (9600);
  motor.attach (servoPin);
  pinMode (schalterGestellPin, INPUT);
  pinMode (schalterHebebObenPin, INPUT);
  pinMode (schalterHebebUntenPin, INPUT);
  pinMode (motorEN_Pin, OUTPUT);
  pinMode (motorA1_Pin, OUTPUT);
  pinMode (motorB1_Pin, OUTPUT);
  pinMode (motorPWM_Pin, OUTPUT);
}

void loop() {
/*  Serial.print ("Gestell: ");
  Serial.println(analogRead (schalterGestellPin));
  Serial.print ("Hebeb: ");
  Serial.println(analogRead (schalterHebebPin)); 
  delay (1000); */
  motorGeschwinigkeit = 0;
  if (analogRead (schalterGestellPin) > 1000) {
    motorGeschwinigkeit = 150;
  }
  if (analogRead (schalterHebebObenPin) > 1000) {
    motorRichtung = 2;
    motorGeschwinigkeit = 0; 
    
    servoKippen (90, 140, 3);
  }
  motorDrehen(motorRichtung, motorGeschwinigkeit);
  if (analogRead (schalterHebebUntenPin) > 1000){
    motorRichtung = 1;
    motorGeschwinigkeit = 0;
  }
}

void motorDrehen(int richtung, int pwm) {

   

  if (richtung == 1) {
    digitalWrite (motorA1_Pin, LOW);
    digitalWrite (motorB1_Pin, HIGH);
  }
  if (richtung == 2) {
    digitalWrite (motorA1_Pin, HIGH);
    digitalWrite (motorB1_Pin, LOW);
  }
  if ((richtung != 1) && (richtung != 2)) {
    digitalWrite (motorA1_Pin, LOW);
    digitalWrite (motorB1_Pin, LOW);
  }
  analogWrite (motorPWM_Pin, pwm);
}

void servoKippen(int startWinkel, int endWinkel, int wiederholungen) {
  for (int i = 0; i <= wiederholungen; i++){
    for (int j = startWinkel; j <= endWinkel; j++){
      motor.write (j);
      delay (40);
    }
    for (int k = endWinkel; k >= startWinkel; k--){
      motor.write (k);
      delay (10);
    }
    delay (200);
  }
}
